var shareId = '';
var uuid = "";
var manufacturer = '';

$(document).ready(function(){
	try{
		document.addEventListener("deviceready", onDeviceReady, false);
	} catch(err) {
		onDeviceReady();
	}
});

function feedback(){
	var feedbackURL = 'http://' + servDomain + '/fb.do';
	$('#feedback').click(function(){
		$('#feedback_form p').html('手机型号:'+device.model + '&nbsp;&nbsp;&nbsp;&nbsp;安卓系统:'+device.platform + device.version);
		$('.mask').show();
		$('#feedback_form').show();
		$('#feedback_form .close').click(function(){
			$('.mask').hide();
			$('#feedback_form').hide();
		});
		$('.mask').click(function(){
			$('.mask').hide();
			$('#feedback_form').hide();
		});
		$('#feedback_form button').click(function(){
			var content = $('#feedback_form textarea').val();
			var contact = $('#feedback_form input').val();
			if(content == ''){
				navigator.notification.alert(
					'请输入您要反馈的内容！',  // message
					'',
					'提示',            // title
					'确定'                  // buttonName
				);
				return;
			}	
			if(contact  == ''){
				navigator.notification.alert(
					'请留下您的联系方式！',  // message
					'',
					'提示',            // title
					'确定'                  // buttonName
				);
				return;
			}	
			$.post(feedbackURL,{content:content, contact:contact, device:device.manufacturer+':'+device.model + ':' +device.platform + device.version,  uuid:uuid},function(data){
				var json_data = eval("(" + data + ")"); 
				if(json_data.succ){
					dialog.prompt('反馈提交成功！');
					$('#feedback_form textarea').val('');
					$('#feedback_form input').val('');
					$('.mask').hide();
					$('#feedback_form').hide();
					return;
				}
				navigator.notification.alert(
					'反馈提交失败，请重试！',
					'',
					'提示',
					'确定'
				);
			});
		});
	});
}

function onDeviceReady() {
	//极光推送
	window.plugins.jPushPlugin.init();
	manufacturer = device.manufacturer.toLowerCase();
	cordova.getAppVersion.getVersionNumber(function (version) {
		channelData['v'] = version;
		logger.send('start', {'model':device.model, 'manuf':manufacturer});
	});

	//反馈	
	feedback();

	//检查升级
	setTimeout(function(){
		updater.check();
	}, 5000);
 
	try{
		fileTransfer.start();
	} catch(err) {
	}

	uuid = getDeviceUUID();


	$('.share ul li').click(function(){
		var scene = $(this).attr('type');
		if(scene.indexOf('Wechat') >= 0){
			wxShare(scene);
		} else if(scene == 'qq'){
			qqShare();
		} else if(scene == 'qzone'){
			qzoneShare();
		} else if(scene == 'weibo'){
			weiboShare();
		} else if(scene == 'album'){
			saveToAlbum();
		}
	});
	var file_md5 = localStorage.getItem('shine_file_md5');
	initImagesList(file_md5, true);

	$('#switchface').click(function(){
		$('.mask').show();
		$('.getpicture').show();
		$('.mask').click(function(){
			$('.mask').hide();
			$('.getpicture').hide();	
		});
		
		var showGuideTip = localStorage.getItem('guidetip');
		if(showGuideTip == null || showGuideTip == undefined) {
			localStorage.setItem('guidetip', 1);
			$('#tip_guide').fadeOut();
		}
	});

	$('.upload').click(function(){
		var permissions = window.plugins.permissions;
		var sourceType = $(this).attr('type');
		permissions.hasPermission(function(status){
			if(!status.hasPermission){
				var errorCallback = function(){
					navigator.notification.alert(
						'为保证逗比相机的正常使用，请前往系统设置开启逗比相机使用摄像头的权限',
						'',
						'提示',
						'确定'
					);
				}

				permissions.requestPermission(function(status){
					if(!status.hasPermission){errorCallback();}
				},  errorCallback, permissions.CAMERA);
			} else {
				cam.init(manufacturer, sourceType);
				cam.start();
			}
		}, null, permissions.CAMERA);
	});

	$(".cancel").click(function(){
		$('.mask').hide();
		$('.getpicture').hide();
	});

}	

function saveToAlbum(){
	var imgs = getImgUrls(shareId);
	var uri = imgs['originImgUrl'];
	logger.send('saveimg', {'url':uri});
	if(manufacturer == 'xiaomi'){
		var fileURL = '/sdcard/DCIM/Camera/' + 'IMG_'+(new Date()).getTime()+".jpg";
	} else {
		var fileURL = '/sdcard/DCIM/' + 'IMG_'+(new Date()).getTime()+".jpg";
	}
	fileTransfer.download(uri, fileURL, function(localFileURL){
		dialog.prompt('保存成功！');
		$('.preview').hide();
		$('.mask').hide();
		$('.share').hide();
	});
}

function getImgUrls(id){
	var thumbImgUrl = $('#' + id).attr('staticurl');
	/*
	var n = thumbImgUrl.lastIndexOf('/');
	var oImgUrl = thumbImgUrl.substring(0, n + 1) + 'o_' + thumbImgUrl.substring(n+1);
	*/
	return {'thumb':thumbImgUrl, 'originImgUrl':thumbImgUrl};
}

function wxShare(scene){
	var scene = (scene == "Wechat.Scene.SESSION") ? Wechat.Scene.SESSION : Wechat.Scene.Timeline;
	$('.preview').hide();
	$('.share').hide();
	Wechat.isInstalled(function (installed) {
		if(!installed){
			alert('没有安装微信客户端！');
			$('.mask').hide();
			return false;
		}
		$('.mask').hide();
		var imgs = getImgUrls(shareId);
		Wechat.share({
			message: {
				title: '闪萌',
				description: '',
				mediaTagName: '',
				messageExt: '',
				messageAction: '',
				thumb:imgs['originImgUrl'],
				media: {
					type: Wechat.Type.IMAGE,
					image: imgs['originImgUrl']
				}
			},
			scene: scene// share to Timeline
		}, function () {
			dialog.prompt('分享微信成功！');
			logger.send('wxshare', {'type':'succ', 'tplid':shareId});
		}, function (failReason) {
			dialog.prompt('分享微信失败！');
			$('.preview').hide();
			$('.mask').hide();
			$('.share').hide();
			logger.send('wxshare', {'type':'fail', 'tplid':shareId, 'msg':failReason});
		});
	}, function (reason) {
		logger.send('wxshare', {'type':'fail', 'msg' : 'not installed'});
		alert('没有安装微信客户端！');
	});
}

function qqShare(){
	$('.preview').hide();
	$('.share').hide();
	YCQQ.checkClientInstalled(function(){
		//dialog.start('分享到QQ...', true);
		$('.mask').hide();
		var imgs = getImgUrls(shareId);
		var fileURL = '/sdcard/shine/share.jpg';
		fileTransfer.download(imgs['originImgUrl'], fileURL, function(localFileURL){
			var args = {};
			args.imageUrl = fileURL;
			args.appName = "闪萌";
			YCQQ.shareToQQ(function(){
				dialog.prompt('分享QQ成功！');
				logger.send('qqshare', {'type':'succ', 'tplid' : shareId});
			},function(failReason){
				dialog.prompt('分享QQ失败！');
				logger.send('qqshare', {'type':'fail', 'tplid' : shareId, 'msg':failReason});
			},args);
		});
	},function(){
		logger.send('qqshare', {'type':'fail', 'msg' : 'not installed'});
		alert('没有安装QQ客户端！');
		$('.mask').hide();
	});
}

function qzoneShare(){
	$('.preview').hide();	
	$('.share').hide();
	var imgs = getImgUrls(shareId);
	var args = {};
	args.url = imgs['originImgUrl'];
	args.title = "闪萌-把自己变成表情包.#闪萌#";
	args.description = '';
	var imgs =[imgs['originImgUrl']];
	args.imageUrl = imgs;
	$('.mask').hide();
	YCQQ.shareToQzone(function () {
		logger.send('qzoneshare', {'type':'succ', 'tplid' : shareId});
		dialog.prompt('分享Qzone成功！');
	}, function (failReason) {
		logger.send('qzoneshare', {'type':'fail', 'tplid' : shareId, 'msg':failReason});
		dialog.prompt('分享Qzone失败！');
	}, args);
}

function weiboShare(){
	window.weibo.isInstalled(function(){
		var imgs = getImgUrls(shareId);
		window.weibo.init('354588090','http://www.meibaoapp.com');
		logger.send('weiboshare', {'type':'succ', 'tplid' : shareId});
		$('.preview').hide();	
		$('.mask').hide();
		$('.share').hide();
		window.weibo.share({
			type: 'image',
			data:  imgs['originImgUrl'],
			text: '闪萌-把自己变成表情包.#闪萌#'
		},function(res){
			/*
			dialog.end();
			$('.mask').hide();
			$('.share').hide();
			logger.send('weiboshare', {'type':'succ', 'tplid' : shareId});
			dialog.end();
			$('.mask').hide();
			$('.share').hide();
			*/
		});	
	}, function(){
		logger.send('weiboshare', {'type':'fail', 'msg' : 'not installed'});
		alert('没有安装微博客户端！');
		$('.preview').hide();	
		$('.mask').hide();
		$('.share').hide();
	});
	/*
	var args = {};
	//args.url= $('#'+shareId).attr('src');
	args.type= 'image';
	args.url= 'http://baidu.com';
	args.title = "闪萌-把自己变成表情包.#闪萌#";
	args.description = '';
	//args.imageUrl = $('#'+shareId).attr('src');
	args.imageUrl = 'https://www.baidu.com/img/bdlogo.png';
	args.defaultText = '';
	YCWeibo.shareToWeibo(function () {
		alert('分享成功！');
	}, function(failReason) {
		alert(failReason);
	}, args);
	*/
}

//初始化列表
function initImagesList(md5, isStart){
	if(!isStart){
		dialog.start('数据加载中...', false);
	}
	var imgpath = '/shine/' + uuid.substr(0,2) + '/' + uuid + '/';
	var containerHtml = '';
	$.ajax({
		type : "get",
		async : false,
		url: 'http://' + servDomain + '/items.do?uuid='+uuid,
		dataType : "jsonp",
		jsonp : "callback", 
		jsonpCallback : "handler", 
		success : function(json) { 
			jsonData = JSON.parse(json);
			for(k in jsonData){
				var cid = jsonData[k]['id'];
				containerHtml += '<h3>' + jsonData[k]["name"] + '</h3><ul>';
				for(tplId in jsonData[k]['tpls']){
					var tplId = tplId.replace('tpl_', '');
					var staticURL = md5 ? 'http://' + imgDomain + imgpath + cid + '_' + tplId + '.png': 'http://' + imgDomain + '/shinetpl/' + cid + '/' + cid + '_' + tplId + '.jpg';
					var val = jsonData[k]['tpls'][tplId];
					containerHtml += '<li><div><img class="lazy" staticurl='+staticURL+' id="img_' + cid + '_' + tplId  + '" data-original="http://'+servDomain+'/img/'+uuid+'_'+md5+'_tpl'+cid+'_'+tplId+'"></div></li>';
				}
				containerHtml += '</ul>';
			}
			$('.container').html(containerHtml);
			$("img.lazy").lazyload();
			$("img.lazy").bind("load",function(){
				var w = $(this).width();
				var h = $(this).height();
				if(h > w){$(this).css('width', w*w/h);$(this).css('height', w)}
			});
			if(isStart){
				navigator.splashscreen.hide();
				//教育气泡
				var showGuideTip = localStorage.getItem('guidetip');
				if(showGuideTip != 1){
					setTimeout(function(){
						$('#tip_guide').fadeIn('slow');
						setTimeout(function(){$('#tip_guide').fadeOut('slow')}, 5000);
					}, 500);
				}
			} else {
				dialog.end();
			}
			$('.container li').click(function(){
				shareId = $(this).children('div').children('img').attr('id');
				$('.mask').show();
				$('.share').show();	
				showImgPreview(shareId, md5);
				$('.preview').click(function(){
					$('.preview').hide();	
					$('.mask').hide();
					$('.share').hide();	
				});
			});
		},
		error : function(rs) {
			alert('数据加载失败...');
		}  
	});
}

function showImgPreview(id, md5){
	var imgURL = $('#'+id).attr('staticurl')+'?_=' + md5;
	$('.preview').show();	
	$('.preview').html('<img src="'+imgURL+'" width=200 />');
}

	
function genUUID() {
	var s = [];
	var hexDigits = "0123456789abcdef";
	for (var i = 0; i < 36; i++) {
		s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
	}
	s[14] = "4";  // bits 12-15 of the time_hi_and_version field to 0010
	s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);  // bits 6-7 of the clock_seq_hi_and_reserved to 01
	s[8] = s[13] = s[18] = s[23] = "-";
	var uuid = s.join("");
	return uuid;
}

//获取设备的唯一码
function getDeviceUUID(){
	var uuid = 'null';
	try{
		uuid = md5(device.uuid);
	}catch(err){
		
		uuid = localStorage.getItem('uuid');
		if(uuid == null || uuid == undefined){
			uuid = md5(genUUID());
			localStorage.setItem('uuid', uuid);
		}
	}
	return uuid;
}

var fileTransfer = {
	//FileTransfer对象，依赖FileTransfer插件
	ft : null,
	//调试模式
	debug : 0,
	//创建对象
	start : function(){
		fileTransfer.ft = new FileTransfer();
	},
	//下载
	download : function(uri, fileURL, callback){
		var permissions = window.plugins.permissions;
		permissions.hasPermission(function(status){
			if(!status.hasPermission){
				var errorCallback = function(){
					navigator.notification.alert(
						'为保证逗比相机的正常使用，请前往系统设置开启逗比相机存储设备的读写权限',
						'',
						'提示',
						'确定'
					);
				}

				permissions.requestPermission(function(status){
					if(!status.hasPermission){errorCallback();}
				},  errorCallback, permissions.WRITE_EXTERNAL_STORAGE);
			} else {
				uri = encodeURI(uri + '?t=' + new Date().getTime());
				fileTransfer.ft.download(
					uri,
					fileURL,
					function(entry) {
						callback(entry.toURL());
					},
					function(error) {
						logger.send('dlfail',{'url':uri, 'local':fileURL,'error':error.source + ':' + error.target + ':' + error.code });
						dialog.end();
						$('.preview').hide();
						$('.mask').hide();
						$('.share').hide();
						alert('文件下载失败！');
					},
					false
					//{ headers: { "Authorization": "Basic "} }
				);
			}
		}, null, permissions.WRITE_EXTERNAL_STORAGE);
	},	

	upload : function(imgData, url, succ, fail, options){
			fileTransfer.ft.upload(imgData, encodeURI(url), succ, fail, options);
	}
};

var cam = {
	options : {
		quality:80,
		destinationType: null,
		sourceType : null,
		saveToPhotoAlbum : true,
		//====关键设置=======================================
		allowEdit:true, //出现裁剪框
		//targetWidth:600,//图片裁剪高度
		//targetHeight:600,//图片裁剪高度
	},

	init : function(manufacturer, type){
		cam.options['sourceType'] = (type == 'camera') ? Camera.PictureSourceType.CAMERA : Camera.PictureSourceType.PHOTOLIBRARY;
		cam.options['saveToPhotoAlbum'] = (type == 'camera') ? true : false;
		cam.options['destinationType'] = Camera.DestinationType.FILE_URL;
		cam.options['allowEdit'] = false;
		/*
		if(manufacturer == 'meizu' && type == 'album'){
			cam.options['saveToPhotoAlbum'] = false;
			cam.options['allowEdit'] = false;
		*/
		if(manufacturer == 'xiaomi' && type == 'camera'){
			cam.options['saveToPhotoAlbum'] = true;
		}
	},	

	start : function(){
		navigator.camera.getPicture(cam.succ, cam.fail, cam.options);
	},

	succ : function(img){
		logger.send('camera_succ', {'msg':img});
		$('.getpicture').hide();
		uploader.init(img);
	},

	fail : function(err){
		logger.send('camera_fail', {'msg':err});
		$('.getpicture').hide();
		$('.mask').hide();
		$('.mask').html('');
	}
};


var uploader = {
	init:function(img){
		dialog.start('换脸中...', false);
		var options = new FileUploadOptions();
		options.fileKey = "file";
		options.fileName = "ishine.jpg";
		options.mimeType = "image/jpeg";
		fileTransfer.upload(
			img, 
			encodeURI("http://" + servDomain + "/identify.do?uuid=" + uuid), 
			uploader.succ,
			uploader.fail,
			options
		);
	},
     
	//上传成功的回调
	succ : function(r) {
		var json_data = eval("(" + r.response + ")"); 
		dialog.end();
		if(json_data.error){
			$('.mask').hide();
			alert(json_data.error);
			dialog.end();
			return false;
		}
		var file_md5 = json_data.succ;
		localStorage.setItem('shine_file_md5', file_md5);
		$('.mask').hide();
		initImagesList(file_md5, false);
	},
 
	//上传失败的回调
	fail : function(error) {
		dialog.end();
		$('.mask').hide();
		$('.mask').html('');
		alert("上传失败，请重试！");
	}
};

//检查网络状态
function checkNetworkState(){
	var networkState = navigator.connection.type;
	if (networkState == Connection.NONE) {
		return false;
	}
	return true;
}

var downloader = {
	dir : '',
	init : function(dir){
		if(!checkNetworkState()){
			alert('请确认您的网络连接正常！');
			return false;
		}
		downloader.dir = dir;
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, downloader.onFileSystemSuccess, downloader.onFileSystemFail);
	},
	
	onFileSystemSuccess : function(fileSystem){
		console.log(fileSystem);
		console.log(downloader.dir);
		newFile = fileSystem.root.getDirectory(
			downloader.dir,
			{ create : true, exclusive : false},
			downloader.onDirectorySuccess,
			downloader.onFileSystemFail
		);  
	},

	onDirectorySuccess : function() {
		console.log('目录创建成功！');
	},

	onFileSystemFail : function(error) {
		console.log("Failed to retrieve file:" + error.code);  
	}
};

//日志
var logger = {
	ua : navigator.userAgent.toLowerCase(),
	width : window.screen.width,
	height : window.screen.height,
	pixelratio : window.devicePixelRatio,
	send : function(name, data){
		var t = new Date().getTime();
		var u = getDeviceUUID();
		var img = new Image();
		var content = '';
		for(k in data){
			content +=  '&' + k + '=' + data[k];
		}
		img.src = 'http://'+pingDomain+'/' + name + '.gif?' + Base64.encode('v='+channelData['v']+'&c='+channelData['id']+'&u=' + u +'&t=' + t + content);
		//img.src = 'http://'+pingDomain+'/' + name + '.gif?' + ('v='+channelData['v']+'&c='+channelData['id']+'&u=' + u +'&t=' + t + content);
	}
};

var dialog = {
	start : function(msg, cancelable){
		cordova.plugin.pDialog.init({
			theme : 'DEVICE_LIGHT',
			progressStyle : 'SPINNER',
			cancelable : cancelable,
			title : '',
			message : msg
		});
	},
	end : function(){
		cordova.plugin.pDialog.dismiss();
	},

	prompt : function(msg){
		dialog.start(msg,true);
		setTimeout(function(){dialog.end()}, 500);
	}
};

var updater = {
	url : 'http://'+servDomain+'/update.do',

	check : function(){
		cordova.getAppVersion.getVersionCode(function(versionCode) {
			var update_not_prompt = localStorage.getItem('update_not_prompt');
			$.post(updater.url,{},function(data){
				var obj = JSON.parse(data);
				if(versionCode < obj.versionCode && (update_not_prompt != obj.versionCode)){
					navigator.notification.confirm(
						obj.msg,
						function(btnIndex){updater.callback(btnIndex, obj.apk, obj.versionCode)},
						'版本升级',
						['升级', '不再提示', '取消']
					);
				}
			});
		});
	},

	callback : function(btnIndex, apkurl, vc){
		if(btnIndex == 1){
			window.open(apkurl, '_system', 'location=yes');
		} else if(btnIndex == 2){
			localStorage.setItem('update_not_prompt', vc);	
		}	
	}
};
